Tutorial for the tasks of the contest. If something isn't clear, you can write in comments :)

Tutorial is loading...

**Code**

```
#include <iostream>
#include <string>
using namespace std;
int main()
{
int n; cin >> n;
string s; cin >> s;
int k_a = 0, k_d = 0;
for (int i = 0; i < n; i++)
if (s[i] == 'A') k_a++; else k_d++;
if (k_a > k_d) cout << "Anton" << endl;
if (k_a < k_d) cout << "Danik" << endl;
if (k_a == k_d) cout << "Friendship" << endl;
return 0;
}
```

Tutorial is loading...

**Code**

```
#include <iostream>
#include <algorithm>
using namespace std;
int main()
{
int k2, k3, k5, k6;
cin >> k2 >> k3 >> k5 >> k6;
int n256 = min(k2, min(k5, k6));
int n32 = min(k3, k2 - n256);
cout << 32 * n32 + 256 * n256 << endl;
return 0;
}
```

Tutorial is loading...

**Code**

```
#include <iostream>
using namespace std;
const int max_n = 1000000;
int n, m, k;
int x, s;
int a[max_n], b[max_n], c[max_n], d[max_n];
inline int max_complete(int money_left)
{
int l = 0, r = k;
while (l < r)
{
int m = (l + r + 1) / 2;
if (d[m] <= money_left) l = m; else r = m-1;
}
return c[l];
}
int main()
{
ios_base::sync_with_stdio(false);
cin >> n >> m >> k;
cin >> x >> s;
a[0] = x;
b[0] = 0;
c[0] = 0;
d[0] = 0;
for (int i = 1; i <= m; i++) cin >> a[i];
for (int i = 1; i <= m; i++) cin >> b[i];
for (int i = 1; i <= k; i++) cin >> c[i];
for (int i = 1; i <= k; i++) cin >> d[i];
long long ans = 1LL * n * x;
for (int i = 0; i <= m; i++)
{
int money_left = s - b[i];
if (money_left < 0) continue;
ans = min(ans, 1LL * (n - max_complete(money_left)) * a[i]);
}
cout << ans << endl;
return 0;
}
```

Tutorial is loading...

**Code**

```
#include <cstdio>
#include <algorithm>
using namespace std;
inline char in_char()
{
char c = '\0';
while (c <= ' ')
c = getchar();
return c;
}
inline int in_int()
{
int n;
scanf("%d", &n);
return n;
}
struct figurine
{
char kind;
int x, y;
};
int n;
int x0, y0;
figurine nearest[8];
inline int dist(int x1, int y1, int x2, int y2)
{
return max(abs(x1 - x2), abs(y1 - y2));
}
inline void upd_nearest(figurine& was, const figurine& cur)
{
if (was.kind == '?' ||
dist(x0, y0, cur.x, cur.y) < dist(x0, y0, was.x, was.y))
was = cur;
}
inline int get_direction(const figurine& cur)
{
// vertical
if (cur.x == x0 && cur.y < y0) return 0;
if (cur.x == x0 && cur.y > y0) return 1;
// horizontal
if (cur.y == y0 && cur.x < x0) return 2;
if (cur.y == y0 && cur.x > x0) return 3;
// diagonal 1
if ((cur.y - y0) == (cur.x - x0) && cur.x < x0) return 4;
if ((cur.y - y0) == (cur.x - x0) && cur.x > x0) return 5;
// diagonal 2
if ((cur.y - y0) == (x0 - cur.x) && cur.y < y0) return 6;
if ((cur.y - y0) == (x0 - cur.x) && cur.y > y0) return 7;
// the piece doesn't lie on any of the eight directions
return -1;
}
int main()
{
n = in_int();
x0 = in_int(); y0 = in_int();
for (int i = 0; i < 8; i++)
nearest[i].kind = '?';
// read and update nearest
for (int i = 0; i < n; i++)
{
figurine cur;
cur.kind = in_char(); cur.x = in_int(); cur.y = in_int();
int dir = get_direction(cur);
if (dir >= 0)
upd_nearest(nearest[dir], cur);
}
bool ans = false;
// check verticals and horizontals
for (int i = 0; i < 4; i++)
if (nearest[i].kind == 'R' || nearest[i].kind == 'Q')
ans = true;
// check diagonals
for (int i = 4; i < 8; i++)
if (nearest[i].kind == 'B' || nearest[i].kind == 'Q')
ans = true;
// output
puts(ans ? "YES" : "NO");
return 0;
}
```

Tutorial is loading...

**Code**

```
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int n;
vector <int> color;
vector < vector <int> > g;
vector <char> used;
vector <int> comp;
int n1;
vector < vector <int> > g1;
vector <int> dp;
int ans = 0;
void dfs1(int v, int col, int cmp)
{
if (used[v]) return;
if (color[v] != col) return;
used[v] = true;
comp[v] = cmp;
for (int i = 0; i < g[v].size(); i++)
{
int to = g[v][i];
dfs1(to, col, cmp);
}
}
void dfs2(int v, int p = -1)
{
int mx1 = 0, mx2 = 0;
for (int i = 0; i < g1[v].size(); i++)
{
int to = g1[v][i];
if (to == p) continue;
dfs2(to, v);
int val = dp[to] + 1;
mx2 = max(mx2, val);
if (mx1 < mx2) swap(mx1, mx2);
}
dp[v] = mx1;
ans = max(ans, mx1 + mx2);
}
int main()
{
ios_base::sync_with_stdio(false);
cin >> n;
color.resize(n);
g.resize(n);
comp.resize(n);
used.assign(n, false);
for (int i = 0; i < n; i++) cin >> color[i];
for (int i = 1; i < n; i++)
{
int a, b; cin >> a >> b; a--, b--;
g[a].push_back(b);
g[b].push_back(a);
}
for (int i = 0; i < n; i++)
if (!used[i])
dfs1(i, color[i], n1++);
g1.resize(n1);
dp.resize(n1);
for (int i = 0; i < n; i++)
for (int j = 0; j < g[i].size(); j++)
{
int to = g[i][j];
if (comp[i] != comp[to])
g1[comp[i]].push_back(comp[to]);
}
dfs2(0);
cout << (ans + 1) / 2 << endl;
return 0;
}
```

Tutorial is loading...

**Code**

```
#include <iostream>
using namespace std;
const int max_n = 300000;
int n;
int b[max_n];
int c[max_n];
int a[max_n];
int d[max_n];
int b1[max_n];
int c1[max_n];
int bits[31][max_n];
int kbit[31];
int main()
{
// input
ios_base::sync_with_stdio(false);
cin >> n;
for (int i = 0; i < n; i++) cin >> b[i];
for (int i = 0; i < n; i++) cin >> c[i];
for (int i = 0; i < n; i++) d[i] = b[i] + c[i];
// searching for answer
long long sum = 0;
for (int i = 0; i < n; i++) sum += d[i];
sum /= (2 * n);
for (int i = 0; i < n; i++) a[i] = (d[i] - sum) / n;
// checking the answer
for (int i = 0; i < n; i++)
if (a[i] < 0)
{
cout << -1 << endl;
return 0;
}
for (int i = 0; i < 31; i++)
for (int j = 0; j < n; j++)
if ((a[j] & (1LL << i)) == 0)
bits[i][j] = 0;
else
bits[i][j] = 1;
for (int i = 0; i < 31; i++)
{
kbit[i] = 0;
for (int j = 0; j < n; j++)
kbit[i] += bits[i][j];
}
for (int i = 0; i < n; i++) b1[i] = 0;
for (int i = 0; i < n; i++) c1[i] = 0;
for (int i = 0; i < 31; i++)
for (int j = 0; j < n; j++)
{
int bbase = bits[i][j] ? kbit[i] : 0;
int cbase = bits[i][j] ? n : kbit[i];
b1[j] += bbase << i;
c1[j] += cbase << i;
}
for (int i = 0; i < n; i++)
if (b1[i] != b[i] || c1[i] != c[i])
{
cout << -1 << endl;
return 0;
}
// output
for (int i = 0; i < n; i++) cout << a[i] << " ";
cout << endl;
return 0;
}
```

Why contest announcement blog is missing? Edit: now it's back!

When should we use it = st.lower_bound(tmp) and it = lower_bound(st.begin(),st.end(),tmp)?

I know first one has logarithmic complexity and second one 'maybe' linear. But in some cases, we can use only second one. I have read this. What exactly is meant by

non-random-access iterators?AC using first

TLE using second

So I was expecting maybe this will give TLE. But it didn't.

it = lower_bound(st.begin(),st.end(),tmp)

for std::vector it is logarithmic complexity

This is regular operations for vectors, arrays, etc. It only works in log N if you can "jump" to a random place in O(1). For example I can look at the x-th element of an array by using array[x-1] in O(1).

This is special function for sets, multisets, maps, etc. It uses a special walk through the tree which C++ constructs for you which has log N complexity. If you use the first method, it will get TLE because you can't "jump" to the x-th element of the set in O(1).

So is the first version

`(logN)^2`

? (Logn time for searching and logn time for accessing element)Why in A is O(1)? I thought it is O(N), isn't it?

Ask your brother :\

It seems to be fixed now. Thank you :)

for problem E, it is possible that you can't decrease the diameter by 2, no matter how you paint the nodes.

Example:

14

0 1 1 1 1 0 0 0 0 0 0 1 1 1

1 2

1 3

1 4

1 5

2 6

2 7

2 8

3 9

4 10

5 11

6 12

7 13

8 14

the diameter of the tree is 5, and no matter which node you paint, the diameter can't be less than 4.

I think the answer is the radius of the tree and each operation can decrease the radius by 1.

Why? In your tree, if I use paint(1), tree diameter will decrease by 4 (it was 6 and became 4). Or I am wrong?

the diameter was 5, right?

12 — 6 — 2 — 1 — 3 — 9 (the longest shortest path)

after you paint(1), the diameter is

12 — 6 — 2 — 7 — 13 (the new longest shortest path)

Yes, got it, you are right.

Sorry, I was wrong :)

But in your example the diameter CAN be decreased by two. Consider paint(2), the diameter becomes 12 — 1 — 3 — 9.

node 1 and 2 are symmetric. paint(1) and paint(2) should be the same.

the new diameter will be 9-3-1-4-10

oh, you are talking about that specific tree

I think it is always possible to reduce the radius by 2, choosing the graph center, if the radius is even.

you must be talking about diameter, not radius. As I said before, it is possible that at one step, you can only reduce the diameter by 1, not 2. But you can always reduce the radius by 1.

Yes, diameter, sorry. You need one step to make diameter even. After that, on each step, it`s always possible to decrease it by 2, so it will remain even. So the answer still will be (d + 1) / 2.

I didn't challenge the result. (d + 1) / 2 is absolute correct. (because that is also the radius of a tree). but the argument provided by OP is not entirely correct.

Thank you, I'll fix it soon.

In problem D, I am getting MLE. Can someone help? code

Thanks!

I think you don't need to save all the point, you only need to consider the nearest chess in eight directions.

Well.. The correct grammar should be "I don't think you need...", my brother:-)

I solved C using BIT by iterating over all second type of spells. BIT maintains the lowest value I can achieve to make potion using cost ≤ some vale. code

Has anyone solved problem E,using dp on compressed tree ?

Great tutorial. Thanks.

Darn I came up with the correct algorithm to solve C but could not implement it properly :(

Regardless, thanks for the great tutorial!!

I tried using DP but couldn't come up with a way :(

pretests of Problem F were a little bit weak... I even passed them all without checking the correctness.Sad story.

Why is the distance in Q4 defined as :

Instead of the normal eucliden distance function

`sqrt(pow(x1-x2,2) + pow(y1-y2,2));`

? I got wrong answer since I used eucliden distance and got an overflow. Why does this distance function work (the one defined in editorial : Q4 : dist function above)In this problem it doesn't matter what distance formula you take. My distance formula is correct because if the two pieces are on one line (horizonal, vertical or diagonal) it can correcly say which one is further from the king (you can check it). As for me, I used this formula because it doesn't give an overflow.

To summarize: we only care about cmp(dist1, dist2). The precise value is not important.

here we are only calculating distances which are diagonal to the given point. So instead of comparing a*sqrt(2) and b*sqrt(2) we are just comparing a and b;

Actually you can change x1, y1, x2, y2 to

`long double`

. GNU++11 has sqrt and pow for long double. Not sure if FP error is tolerable though.In problem E, I still don't understand the meaning of "changes the color of all vertices u such that all vertices on the shortest path from v to u have the same color". Could someone please explain how this operation works for me?

To paint node

u, let it be of color white. Then do dfs fromuand cover all those nodes that are white and reachable fromu. Do not dfs to black nodes. Finally as you traverse nodes, paint them to black.i did the same thing but by doing it , i get ans = 4 for test case 3 whereas it is 3, can u explain how is it 3?

I ran into the same result at first. For me, it turned out that it is not enough just to count the connected components with the same color. You also have to account for solutions where a component is repainted multiple times, such that the component grows with each repainting. The tutorial is actually pretty good on this. Hope this helps.

Can you elaborate on why a component would be repainted multiple times?

I got confused too and had to basically ignore this whole problem.

The pitfall is, while the “such that” clause is intended to describe the selection of u, non-native speakers may confuse “such that” with “so that”, and interpret the clause as the result of the operation. Compare:

For problem C: http://codeforces.com/contest/734/submission/22247048 Can someone help me understand why this solution fails ?

It's gonna TLE anyways i think . Your solution complexity is O(m*k), when all spells of the first and second kind have cost <= s .

Regarding WA , You don't consider the possibility when the answer comes from just using a spell of the first kind . remove

`if(flag==0)break;`

You're right , i know this would time out definitely .

Actually

`if(flag==1) break;`

runs only after the loop for using the first spell has already been used .You can miss out on checking some spells of first kind . Removing

`if(flag==1)break;`

fixes this . http://codeforces.com/contest/734/submission/22258886Thanks !

Why does this get WA for Div2E ? http://codeforces.com/contest/734/submission/22258547

Thank u everyone..!

I really appreciate problem E, thanks for such a good problem!

In Problem E, please explain this " This operation changes the color of all vertices u such that all vertices on the shortest path from v to u have the same color (including v and u) ". thanks

In the last problem how do you go from "from where ..." To "Now it's not hard to find ai: ..."

In (Problem C — Anton and Making Potions, what if we do not use the upper_bound function?

What if I instead sort the first array based on points (m log m), and use two pointers? (order m + k).

I felt this should also work, since the complexity is O(m log m + k), but it is giving me TLE.

Could someone please help me understand why this isn't working?

My Code — CODE

You are calling

`vector::erase`

in the middle, which takes O(len). If you filter`vp`

and put the results in a new vector, this program should work.btw, you can keep those spells and still get the right answer, so why bother removing them? :)

Thankyou so so much. That fixed it :) I wish I had thought of that during the contest.

ACCEPTED ANSWER

Thank you very much!!!

It was hard to find a solution during contest, but after reading the editorial the solutions were pretty clear and easy to understand. Also implementation was not diffcult. This is the first round I was able to solve all problems. Thanks for really well-made problems, alex256.

Yes, I agree with you.

Why is my solution giving WA for, it uses the same binary search logic as in the editorial ? http://codeforces.com/contest/734/submission/22262919

You can see my code. http://codeforces.com/contest/734/submission/22262314

Try

`b[i] < s`

instead of`b[i] <= s`

.Ah yes, with b[i] >= s , he can still buy that. Thanks :)

Very well written editorial. Thanks!

Thanks for your editorial.

For F, why is complexity ? We have a loop over the digits, which takes . However, can someone explain why

valisO(n)?Yes, you are right, I'll fix it soon.

Did anybody do E with dp on tree??

Had to say — a perfect implementation of question C , learned a lot .thanks alex256

any idea what does test 43 in D do ? I keep getting WA in it

D. Anton and Chess when I run code in my codeblocks the answer is right for test 2. But when I submit the same code to the system. the system is run different result from me. Can someone help me? http://codeforces.com/contest/734/submission/22280387

For problem C: http://codeforces.com/contest/734/submission/22284393 Can someone help me understand why this solution WA ?

using greedy & two pointer

100 1 1

1000 5

1

6

95

4

Answer : 5000

can you explain why answer is 5000??

Use second spell of second type.

thanks ^_^

WA again :D

http://codeforces.com/contest/734/submission/22291838

how ?

for problem E where is my code is wrong http://codeforces.com/contest/734/submission/22295869

Hi! Can someone help me to know why this submission give wrong answer! Problem D — http://codeforces.com/contest/734/submission/22316916

It's one of those days which you make dumb mistakes that makes you feel bad.

2

2 2

R 1 1

B 3 3

OMG!! big mistake! Thank u for your help :-)

Hi! Can someone help me to know why this submission give wrong answer! Problem E — http://codeforces.com/contest/734/submission/22295869

Would you mind explain a bit about the logic behind your solution? It appears that you have a different approach compared to the editorial.

i apply the same logic as given in the editorial but in short way means first i find the leaf node using dfs1() than i find the diameter using dfs2() in such a way that if i go from node1 > node2 and both have diff color than increment in cnt and after this print cnt/2 (diameter/2) in ans.

Hmm, I don't think that's what your code means. What your code does is just selecting the last visited node in the first bfs rooted at 1, as the root, and search for the furthest node from the new root in the compressed tree. To my understanding that is not how you find the diameter of the tree.

To find out the diameter of a tree, first assign an arbitrary node as the root, then for each node, check for the sum of the two children which has the maximum depth. The maximized value is the diameter.

thanx i got it but can u send me a simple code for findinh the diameter of a graph plz......

http://codeforces.com/contest/734/submission/22280991

dfs1() is used for condensing nodes, and dfs2() is used for finding the diameter of the graph.

thanx alot sir.............

How the complexity of problem c code is O(m.logK + k) ?

foreach m first spells, binary search through a list of size k. O(mlogk)

foreach k second spells, consider each individually. O(k)

Edit: Formatting

In D, why answer of test3 is 3? I found it is 4, isn't it?

try paint(3) thrice

OMG! It is magic! Thank you very much! :)

Could someone explain to me what the

`paint`

operation does in the problem E (Anton and Tree)? In particular, I don't understand this:`We denote it as paint(v), where v is some vertex of the tree. This operation changes the color of all vertices u such that all vertices on the shortest path from v to u have the same color (including v and u)`

. Does the color of v always have to change? In the example tree, why does after`paint(3)`

, all but node 6 get painted black? Take the shortest part from 3 to 6, is it also valid to make 5 white?Thanks in advance!

Can someone please help me figure out why is this WA for C problem? Went through all the comments , can't figure out what the problem is.Thanks!(http://codeforces.com/contest/734/submission/22342679)

Nevermind ! Got the mistake :)

Problem C: I am getting wa in test case 3. How the result is 10 in this case????

Regarding Problem 379F — Anton and School, Why can't the correctness be checked directly by generating b & c using;

bi = (ai and a1) + (ai and a2) + ... + (ai and an) ci = (ai or a1) + (ai or a2) + ... + (ai or an)

If one doesn't derive the correctness formula as in the editorial, then does this naive approach result in time limit exceeded?

The correctness is checked exactly in this way.

If you compute

bandcin the naive way, just using the formula from the statement, you'll do that in , which won't fit in TL.Thank you very much

Regarding Problem 379E — Anton and Tree, the editorial shows a proof for upper limit on number of operations needed i.e. (d+1)/2, but which step of the proof states that this is exactly the number of operations needed?

Could anyone arrive at an iterative solution to the DFS instead of the recursive ones shown in the editorial?

It was proved in the editorial that we can always paint the tree in operations, please read it carefully.

"Now, we'll prove that it's always possible to paint the tree in operations. Find such vertex that the shortest path from it to any other vertex doesn't exceed . Such vertex can always be found, because otherwise the tree diameter won't be less that d + 1, which is impossible. Now see that if we paint this vertex times, we will paint the tree in one color."I am afraid I can not really understand this explanation very well. Do you use a proof of contradiction? If you could please rephrase it a little or provide any external material to help me understand it better, I should be very grateful.

Thanks for the help, I was stuck on C.

for (int i = 0; i < 31; i++) for (int j = 0; j < n; j++) if ((a[j] & (1LL << i)) == 0) bits[i][j] = 0; else bits[i][j] = 1;

Can someone explain me those lines for me from problem F??

`bits[i][j]`

means thei-th bit of`a[j]`

Can anyone explain to me why the answer to problem E is (d+1)/2? Thanks a lot :D

For problem F, why is it not sufficient that summation of d(i) be divisible by 2n and a(i) be divisible by n and non-negative i.e. why do we have to check for correctness ?

c[i] must be greater than b[i], because ai or ak >= ai and ak. Using d[i] you lose this property. If you swap b[i] and c[i] for a problem with solution you would obtain a problem without solution but same array d.

Not only this. Consider this test case:

Answer is

`-1`

but the solution without restoring the answer will output`1 1 1 1`

Problem F: Is there a intuitive/combinatorial way to see that (a & b) + (a | b) = a + b ?

First you add all the powers of 2 once that occur in either a or b (a | b), but then you might have missed some that occured in both! So we add all the powers once more that occured in both (a & b)

For problem C : O(m*log(k)) solution

Hi, could somebody help me figure out the problem with this submission for problem

C: Anton and Making Potions.Algorithm:

Here is the submission number 22677789.

I updated some code and still it WA. Can anybody please help?

Result could be assigned to a overflowed value (n*x)

It still fails, though on another test case.22677978.

100 1 3

100 100

1

10

1 90 95

1 90 90

Try this case, you will see why your binary search is flawed.

Ah! I somehow made the assumption that numbers will be unique. Thank you very much! AC now.

I am getting wrong answer in test case 6 of of Problem 734C. My submission

Hi! My code for problem E is getting RTE in test case 2. But the code runs successfully on my pc, including test case 2. Can anyone help me find out what's the problem? Code: http://codeforces.com/contest/734/submission/22926048

F good problem!

can anybody explain problem D , test case is giving WA (5th test case) http://codeforces.com/contest/734/submission/23343680

In problem C. Anton and Making Potions

this line gets WA in case 16

between editing it to

gets AC..why ?

also here the full submissions:

http://codeforces.com/contest/734/submission/23527242 (WA)

http://codeforces.com/contest/734/submission/23527311 (AC)

Its because lower_bound gives the first occurrence of the number to be found. It may be a case where there are multiple c[i] possible for the same money_left.

We have to find the last occurrence for this money_left.

Let's say the array c and d are:

c=[1, 2, 3, 4, 5];

d=[10, 10, 11, 12, 13];

Now if the money left is 10 , then the max value in c will be 2.

Using int j=lower_bound(d.begin(),d.end(),s-b[i])-d.begin(); will give 1.

So to get the last occurrence we have to add 1 to the money_left which will return the last occurrence of the required answer.

Can someone please explain a dynamic programming approach to problem E-thanks in advance :) !Problem F: Anton ans School: Can someone please explain why do we need to recheck the found the solution i.e array a by rebuilding array b and array c from array a. Can't we simply say that if all the a[i] found are integers then the array a will be a valid solution else even if a single a[i] happens to be a non-integer then there will be no valid solution? Thanks in advance!

For problem B.

What if the two numbers are co-primes? or even x % y != 0?

Would it be still the same problem and we can go greedily?

in problem E Can't we just count number of unconnected white color nodes and unconnected black nodes and print minimum of them ....

That approach doesn't give the most optimal answer.

Read the editorial, you'll probably understand better

If I take input of the first problem(734A) using a loop:

.................... it gives runtime error in test 6 when the value of n is 200 or above . If I directly take input using string s; cin>>s; the problem does not occur.What is the reason behind it?